package javax.print.attribute;

import java.util.Vector;
import java.io.Serializable;

public abstract class SetOfIntegerSyntax implements Serializable, Cloneable
{
    private static final long serialVersionUID = 3666874174847632203L;
    private int[][] members;
    
    protected SetOfIntegerSyntax(String s) {
        this.members = parse(s);
    }
    
    private static int[][] parse(String s) {
        Vector<Object> vector = new Vector();
        int n = (s == null) ? 0 : s.length();
        int i = 0;
        int n2 = 0;
        int n3 = 0;
        int n4 = 0;
        while (i < n) {
            int char1 = s.charAt(i++);
            switch (n2) {
                case 0: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 0;
                        continue;
                    }
                    int digit;
                    if ((digit = Character.digit((char)char1, 10)) != -1) {
                        n3 = digit;
                        n2 = 1;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 1: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 2;
                        continue;
                    }
                    int digit2;
                    if ((digit2 = Character.digit((char)char1, 10)) != -1) {
                        n3 = 10 * n3 + digit2;
                        n2 = 1;
                        continue;
                    }
                    if (char1 == '-' || char1 == ':') {
                        n2 = 3;
                        continue;
                    }
                    if (char1 == ',') {
                        accumulate(vector, n3, n3);
                        n2 = 6;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 2: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 2;
                        continue;
                    }
                    if (char1 == '-' || char1 == ':') {
                        n2 = 3;
                        continue;
                    }
                    if (char1 == ',') {
                        accumulate(vector, n3, n3);
                        n2 = 6;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 3: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 3;
                        continue;
                    }
                    int digit3;
                    if ((digit3 = Character.digit((char)char1, 10)) != -1) {
                        n4 = digit3;
                        n2 = 4;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 4: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 5;
                        continue;
                    }
                    int digit4;
                    if ((digit4 = Character.digit((char)char1, 10)) != -1) {
                        n4 = 10 * n4 + digit4;
                        n2 = 4;
                        continue;
                    }
                    if (char1 == ',') {
                        accumulate(vector, n3, n4);
                        n2 = 6;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 5: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 5;
                        continue;
                    }
                    if (char1 == ',') {
                        accumulate(vector, n3, n4);
                        n2 = 6;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
                case 6: {
                    if (Character.isWhitespace((char)char1)) {
                        n2 = 6;
                        continue;
                    }
                    int digit5;
                    if ((digit5 = Character.digit((char)char1, 10)) != -1) {
                        n3 = digit5;
                        n2 = 1;
                        continue;
                    }
                    throw new IllegalArgumentException();
                }
            }
        }
        switch (n2) {
            case 0: {
                break;
            }
            case 1:
            case 2: {
                accumulate(vector, n3, n3);
                break;
            }
            case 4:
            case 5: {
                accumulate(vector, n3, n4);
                break;
            }
            case 3:
            case 6: {
                throw new IllegalArgumentException();
            }
        }
        return canonicalArrayForm(vector);
    }
    
    private static void accumulate(Vector vector, int n, int n2) {
        if (n <= n2) {
            vector.add(new int[] { n, n2 });
            for (int i = vector.size() - 2; i >= 0; --i) {
                int[] obj = (int[])(int[])vector.elementAt(i);
                int n3 = obj[0];
                int n4 = obj[1];
                int[] obj2 = (int[])(int[])vector.elementAt(i + 1);
                int n5 = obj2[0];
                int n6 = obj2[1];
                if (Math.max(n3, n5) - Math.min(n4, n6) <= 1) {
                    vector.setElementAt(new int[] { Math.min(n3, n5), Math.max(n4, n6) }, i);
                    vector.remove(i + 1);
                }
                else if (n3 > n5) {
                    vector.setElementAt(obj2, i);
                    vector.setElementAt(obj, i + 1);
                }
                else {
                    break;
                }
            }
        }
    }
    
    private static int[][] canonicalArrayForm(Vector vector) {
        return (int[][])(int[][])vector.toArray(new int[vector.size()][]);
    }
    
    protected SetOfIntegerSyntax(int[][] array) {
        this.members = parse(array);
    }
    
    private static int[][] parse(int[][] array) {
        Vector<Object> vector = new Vector();
        int n = (array == null) ? 0 : array.length;
        int i = 0;
        while (i < n) {
            int n2;
            int n3;
            if (array[i].length == 1) {
                n3 = (n2 = array[i][0]);
            }
            else if (array[i].length == 2) {
                n2 = array[i][0];
                n3 = array[i][1];
            }
            else {
                throw new IllegalArgumentException();
            }
            if (n2 <= n3 && n2 < 0) {
                throw new IllegalArgumentException();
            }
            accumulate(vector, n2, n3);
            ++i;
        }
        return canonicalArrayForm(vector);
    }
    
    protected SetOfIntegerSyntax(int n) {
        if (n < 0) {
            throw new IllegalArgumentException();
        }
        this.members = new int[][] { { n, n } };
        return;
    }
    
    protected SetOfIntegerSyntax(int n, int n2) {
        if (n <= n2 && n < 0) {
            throw new IllegalArgumentException();
        }
        this.members = ((n <= n2) ? new int[][] { { n, n2 } } : new int[0][]);
        return;
    }
    
    public int[][] getMembers() {
        int length = this.members.length;
        int[][] array = new int[length][];
        for (int i = 0; i < length; ++i) {
            array[i] = new int[] { this.members[i][0], this.members[i][1] };
        }
        return array;
    }
    
    public boolean contains(int n) {
        int length = this.members.length;
        int i = 0;
        while (i < length) {
            if (n < this.members[i][0]) {
                return false;
            }
            if (n <= this.members[i][1]) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public boolean contains(IntegerSyntax integerSyntax) {
        return this.contains(integerSyntax.getValue());
    }
    
    public int next(int n) {
        int length = this.members.length;
        int i = 0;
        while (i < length) {
            if (n < this.members[i][0]) {
                return this.members[i][0];
            }
            if (n < this.members[i][1]) {
                return n + 1;
            }
            ++i;
        }
        return -1;
    }
    
    @Override
    public boolean equals(Object o) {
        if (o != null && o instanceof SetOfIntegerSyntax) {
            int[][] members = this.members;
            int[][] members2 = ((SetOfIntegerSyntax)o).members;
            int length = members.length;
            if (length == members2.length) {
                int i = 0;
                while (i < length) {
                    if (members[i][0] != members2[i][0] || members[i][1] != members2[i][1]) {
                        return false;
                    }
                    ++i;
                }
                return true;
            }
            return false;
        }
        else {
            return false;
        }
    }
    
    @Override
    public int hashCode() {
        int n = 0;
        for (int length = this.members.length, i = 0; i < length; ++i) {
            n += this.members[i][0] + this.members[i][1];
        }
        return n;
    }
    
    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        for (int length = this.members.length, i = 0; i < length; ++i) {
            if (i > 0) {
                sb.append(',');
            }
            sb.append(this.members[i][0]);
            if (this.members[i][0] != this.members[i][1]) {
                sb.append('-');
                sb.append(this.members[i][1]);
            }
        }
        return sb.toString();
    }
}
